com.google.api.server.spi.config

## Annotation Type ApiClass

-     @Retention(value=RUNTIME)
       @Target(value=TYPE)
      public @interface ApiClass

  Annotation for configuration specific to an API class.

- - ### Optional Element Summary

    Optional Elements
    Modifier and Type | Optional Element and Description
    --- | ---
    `java.lang.String[]` | `audiences` Audience for IdTokens, applicable to all methods of the API class unless overridden by `@ApiMethod#audiences`.
    `java.lang.Class<? extends Authenticator>[]` | `authenticators` Custom authenticators, applicable to all methods of the API class unless overridden by `@ApiMethod#authenticators`.
    `AuthLevel` | `authLevel` Set frontend auth level, applicable to all methods of the API unless overridden by `@ApiMethod#authLevel`.
    `java.lang.String[]` | `clientIds` Client IDs allowed to call this method, applicable to all methods of the API class unless overridden by `@ApiMethod#clientIds`.
    `java.lang.Class<? extends PeerAuthenticator>[]` | `peerAuthenticators` Custom peer authenticators, applicable to all methods of the API class unless overridden by `@ApiMethod#peerAuthenticators`.
    `java.lang.String` | `resource` The name (in plural) of the resource collection.
    `java.lang.String[]` | `scopes` OAuth 2 scopes, one of which is required for calling this method, applicable to all methods of the API class unless overridden by `@ApiMethod#scopes`.
    `AnnotationBoolean` | `useDatastoreForAdditionalConfig` `AnnotationBoolean.TRUE` to request that overriding configuration be loaded from the appengine datastore.

- - ### Element Detail

    - #### resource

          public abstract java.lang.String resource

      The name (in plural) of the resource collection. It is used as a part of the RESTful path and RPC method name. If it is left empty, a value is deduced from inspecting each endpoint method.
      Default:
        ""

  - - #### authLevel

          public abstract AuthLevel authLevel

      Set frontend auth level, applicable to all methods of the API unless overridden by `@ApiMethod#authLevel`.
      Default:
        com.google.api.server.spi.config.AuthLevel.UNSPECIFIED

  - - #### scopes

          public abstract java.lang.String[] scopes

      OAuth 2 scopes, one of which is required for calling this method, applicable to all methods of the API class unless overridden by `@ApiMethod#scopes`.
      Default:
        "_UNSPECIFIED_LIST_STRING_VALUE"

  - - #### audiences

          public abstract java.lang.String[] audiences

      Audience for IdTokens, applicable to all methods of the API class unless overridden by `@ApiMethod#audiences`.
      Default:
        "_UNSPECIFIED_LIST_STRING_VALUE"

  - - #### clientIds

          public abstract java.lang.String[] clientIds

      Client IDs allowed to call this method, applicable to all methods of the API class unless overridden by `@ApiMethod#clientIds`.
      Default:
        "_UNSPECIFIED_LIST_STRING_VALUE"

  - - #### authenticators

          public abstract java.lang.Class<? extends Authenticator>[] authenticators

      Custom authenticators, applicable to all methods of the API class unless overridden by `@ApiMethod#authenticators`.
      Default:
        com.google.api.server.spi.config.Authenticator.class

  - - #### peerAuthenticators

          public abstract java.lang.Class<? extends PeerAuthenticator>[] peerAuthenticators

      Custom peer authenticators, applicable to all methods of the API class unless overridden by `@ApiMethod#peerAuthenticators`.
      Default:
        com.google.api.server.spi.config.PeerAuthenticator.class

  - - #### useDatastoreForAdditionalConfig

          public abstract AnnotationBoolean useDatastoreForAdditionalConfig

      `AnnotationBoolean.TRUE` to request that overriding configuration be loaded from the appengine datastore.
      Default:
        com.google.api.server.spi.config.AnnotationBoolean.UNSPECIFIED